#include <tchar.h>
#include "CP2112_I2C.h"
#include "resource.h"

#define VID				0x10C4
#define PID				0xEA90

bool i2c_dev_det_flag = FALSE;
bool i2c_connect_flag = FALSE;

void CP2112_I2C::DispLibVer(HWND hWnd) {
    BYTE major;
    BYTE minor;
    BOOL release;

    if (HidSmbus_GetLibraryVersion(&major, &minor, &release) == HID_SMBUS_SUCCESS)
    {
        TCHAR version[40];
        wsprintf(version, _T("LibVer: %d.%d"), major, minor);
        SetWindowText(GetDlgItem(hWnd, IDC_STATIC_LIBVER), version);
    }
    if (HidSmbus_GetHidLibraryVersion(&major, &minor, &release) == HID_SMBUS_SUCCESS)
    {
        TCHAR version[40];
        wsprintf(version, _T("HidLibVer: %d.%d"), major, minor);
        SetWindowText(GetDlgItem(hWnd, IDC_STATIC_HIDLIBVER), version);
    }

    SetWindowText(GetDlgItem(hWnd, IDC_EDIT_PWM_CH), "0");
    SetWindowText(GetDlgItem(hWnd, IDC_EDIT_H_EDGE), "0");
    SetWindowText(GetDlgItem(hWnd, IDC_EDIT_L_EDGE), "4095");

}

void CP2112_I2C::DispDev(HWND hWnd) {
    TCHAR dev_info[100];
    DWORD					numDevices;
    HID_SMBUS_DEVICE_STR	deviceString;

    if (HidSmbus_GetNumDevices(&numDevices, VID, PID) == HID_SMBUS_SUCCESS)
    {
        wsprintf(dev_info, _T("devicenum = %d"), numDevices);
        SetWindowText(GetDlgItem(hWnd, IDC_STATIC_DETDEV), dev_info);

        if (numDevices > 0)
        {
            i2c_dev_det_flag = TRUE;
            if (HidSmbus_GetString(0, VID, PID, deviceString, HID_SMBUS_GET_SERIAL_STR) == HID_SMBUS_SUCCESS)
            {
                wsprintf(dev_info, _T("VID:0x%x, PID:0x%x,SERIAL:0x%x"), VID, PID, deviceString);
                SetWindowText(GetDlgItem(hWnd, IDC_STATIC_DETDEV2), dev_info);
            }
        }
        else {
            i2c_dev_det_flag = FALSE;
            wsprintf(dev_info, _T("VID:----, PID:----, SERIAL:----"));
            SetWindowText(GetDlgItem(hWnd, IDC_STATIC_DETDEV2), dev_info);
        }
    }
}

void CP2112_I2C::ConnectDev(HWND hWnd) {
    TCHAR dev_info[100];
    BYTE    writeData[HID_SMBUS_MAX_WRITE_REQUEST_SIZE];
    BOOL opened;
    HID_SMBUS_STATUS status;

    if (i2c_dev_det_flag == TRUE)
    {
        if (i2c_connect_flag == FALSE)
        {
            status = HidSmbus_Open(&m_hidSmbus, 0, VID, PID);

            wsprintf(dev_info, _T("HidSmbus_Open(): %s"), HidSmbus_DecodeErrorStatus(status));
            SetWindowText(GetDlgItem(hWnd, IDC_STATIC_STATUS), dev_info);

            if (status == HID_SMBUS_SUCCESS)
            {
                wsprintf(dev_info, _T("Connected"));
                SetWindowText(GetDlgItem(hWnd, IDC_STATIC_CONNECT), dev_info);
                wsprintf(dev_info, _T("Disconnect"));
                SetWindowText(GetDlgItem(hWnd, IDC_BTN_CONNECT), dev_info);

                m_pHidSmbus = &m_hidSmbus;
                if (HidSmbus_IsOpened(*m_pHidSmbus, &opened) == HID_SMBUS_SUCCESS && opened)
                {
                    status = HidSmbus_GetSmbusConfig(*m_pHidSmbus, &m_bitRate, &m_ackAddress, &m_autoRespond,
                        &m_writeTimeout, &m_readTimeout, &m_sclLowTimeout, &m_transferRetries);
                    if (status == HID_SMBUS_SUCCESS)
                    {
                        wsprintf(dev_info, _T("Clock Speed : %d [Hz]"), m_bitRate);
                        SetWindowText(GetDlgItem(hWnd, IDC_STATIC_CLK), dev_info);
                        wsprintf(dev_info, _T("Slave Address : %d"), m_ackAddress);
                        SetWindowText(GetDlgItem(hWnd, IDC_STATIC_SLVADDR), dev_info);
                    }
                }
                 
                i2c_connect_flag = TRUE;
                m_addressedSlaveAddress = 0x80;

                //sleep modeAAuto Incrementɐݒ
                writeData[0] = 0x00;
                writeData[1] = 0x11;
                status = HidSmbus_WriteRequest(*m_pHidSmbus, m_addressedSlaveAddress, writeData, 2);
                if (status != HID_SMBUS_SUCCESS)
                {
                    MessageBox(NULL, "sleep modeAAuto IncrementݒɎs܂B", "Error", MB_OK);
                }

                //g̕ύXSleep modeŎ{Kv
                //48.828Hz(px̐x0.5/LSB)ɐݒ (S03T 2BBMG)
                //54.253Hz(px̐x0.5/LSB)ɐݒ (MG996R)
                writeData[0] = 0xFE;
                //writeData[1] = 0x7C; //S03T 2BBMG
                writeData[1] = 0x70; //MG996R
                status = HidSmbus_WriteRequest(*m_pHidSmbus, m_addressedSlaveAddress, writeData, 2);
                if (status != HID_SMBUS_SUCCESS)
                {
                    //MessageBox(NULL, "48.828Hz(px̐x0.5/LSB)ݒɎs܂B", "Error", MB_OK);
                    MessageBox(NULL, "54.253Hz(px̐x0.5/LSB)ݒɎs܂B", "Error", MB_OK);
                }

                //sleep modeAAuto Incrementɐݒ
                writeData[0] = 0x00;
                writeData[1] = 0x21;
                status = HidSmbus_WriteRequest(*m_pHidSmbus, m_addressedSlaveAddress, writeData, 2);
                if (status != HID_SMBUS_SUCCESS)
                {
                    MessageBox(NULL, "sleep modeAAuto IncrementݒɎs܂B", "Error", MB_OK);
                }
            }
        }
        else {
            HID_SMBUS_STATUS status = HidSmbus_Close(m_hidSmbus);
            m_hidSmbus = NULL;
            wsprintf(dev_info, _T("HidSmbus_Close(): %s"), HidSmbus_DecodeErrorStatus(status));
            SetWindowText(GetDlgItem(hWnd, IDC_STATIC_STATUS), dev_info);

            if (status == HID_SMBUS_SUCCESS)
            {
                wsprintf(dev_info, _T("Disconnected"));
                SetWindowText(GetDlgItem(hWnd, IDC_STATIC_CONNECT), dev_info);
                wsprintf(dev_info, _T("Connect"));
                SetWindowText(GetDlgItem(hWnd, IDC_BTN_CONNECT), dev_info);
                wsprintf(dev_info, _T("Clock Speed : --"));
                SetWindowText(GetDlgItem(hWnd, IDC_STATIC_CLK), dev_info);
                wsprintf(dev_info, _T("Slave Address : --"));
                SetWindowText(GetDlgItem(hWnd, IDC_STATIC_SLVADDR), dev_info);
                i2c_connect_flag = FALSE;
            }
        }
    }
}

void CP2112_I2C::DisconnectDev(HWND hWnd) {
    TCHAR dev_info[100];

    if (i2c_dev_det_flag == TRUE)
    {
        if (i2c_connect_flag == TRUE)
        {
            HID_SMBUS_STATUS status = HidSmbus_Close(m_hidSmbus);
            m_hidSmbus = NULL;
            wsprintf(dev_info, _T("HidSmbus_Close(): %s"), HidSmbus_DecodeErrorStatus(status));
            SetWindowText(GetDlgItem(hWnd, IDC_STATIC_STATUS), dev_info);

            if (status == HID_SMBUS_SUCCESS)
            {
                wsprintf(dev_info, _T("Disconnected"));
                SetWindowText(GetDlgItem(hWnd, IDC_STATIC_CONNECT), dev_info);
                wsprintf(dev_info, _T("Connect"));
                SetWindowText(GetDlgItem(hWnd, IDC_BTN_CONNECT), dev_info);
                i2c_connect_flag = FALSE;
            }
        }
    }
}

void CP2112_I2C::I2cRead(HWND hWnd) {
    TCHAR text_data[100];
    BYTE targetAddress;
    HID_SMBUS_S0	status0;
    BYTE			buffer[HID_SMBUS_MAX_READ_RESPONSE_SIZE] ;
    BYTE			numBytesRead = 0;

    m_addressedBytesToRead = 1;
    m_targetAddressSize = 1;
    targetAddress = 0x00;// 0xFE;
    m_forceBytesToRead = 1;
    

    if (i2c_connect_flag == TRUE)
    {
        GetWindowText(GetDlgItem(hWnd, IDC_EDIT_RADDR), text_data, 99);
        targetAddress = strtol(text_data, NULL, 16);
        if (targetAddress < 0 or targetAddress > 255) {
            MessageBox(NULL, "ReadAhX0x00`0xFF͈̔͊OłB", "Error", MB_OK);
            return;
        }

        HID_SMBUS_STATUS status = HidSmbus_AddressReadRequest(*m_pHidSmbus, m_addressedSlaveAddress,
                                                 m_addressedBytesToRead, m_targetAddressSize, &targetAddress);

        if (status == HID_SMBUS_SUCCESS)
        {
            HID_SMBUS_STATUS status = HidSmbus_ForceReadResponse(*m_pHidSmbus, m_forceBytesToRead);

            if (status == HID_SMBUS_SUCCESS)
            {
                HID_SMBUS_STATUS status = HidSmbus_GetReadResponse(*m_pHidSmbus, &status0, buffer,
                                                             HID_SMBUS_MAX_READ_RESPONSE_SIZE, &numBytesRead);
                if (status == HID_SMBUS_SUCCESS)
                {
                    wsprintf(text_data, _T("%02x"),buffer[0]);
                    SetWindowText(GetDlgItem(hWnd, IDC_STATIC_RDATA_RSLT), text_data);
                }
            }

        }
    }
}

void CP2112_I2C::I2cWrite(HWND hWnd) {
    TCHAR   text_data[100];
    BYTE    in_data;
    BYTE    writeData[HID_SMBUS_MAX_WRITE_REQUEST_SIZE];
    BYTE    numBytesToWrite = 2;

    if (i2c_connect_flag == TRUE)
    {
       
        GetWindowText(GetDlgItem(hWnd, IDC_EDIT_WADDR), text_data, 99);
        in_data = strtol(text_data, NULL, 16);
        if (in_data < 0 or in_data > 255) {
            MessageBox(NULL, "WriteAhX0x00`0xFF͈̔͊OłB", "Error", MB_OK);
            return;
        }
        writeData[0] = in_data;

        GetWindowText(GetDlgItem(hWnd, IDC_EDIT_WDATA), text_data, 99);
        in_data = strtol(text_data, NULL, 16);
        if (in_data < 0 or in_data > 255) {
            MessageBox(NULL, "Writef[^0x00`0xFF͈̔͊OłB", "Error", MB_OK);
            return;
        }
        writeData[1] = in_data;

        HID_SMBUS_STATUS status = HidSmbus_WriteRequest(*m_pHidSmbus, m_addressedSlaveAddress,
                                                        writeData, numBytesToWrite);
        if (status != HID_SMBUS_SUCCESS)
        {
            MessageBox(NULL, "WriteɎs܂B", "Error", MB_OK);
        }
    }
}

void CP2112_I2C::PWM_Set(HWND hWnd) {
    TCHAR   text_data[100];
    BYTE    targetCh;
    unsigned short in_data;
    BYTE    writeData[HID_SMBUS_MAX_WRITE_REQUEST_SIZE];
    BYTE    numBytesToWrite = 5;

    if (i2c_connect_flag == TRUE)
    {
        GetWindowText(GetDlgItem(hWnd, IDC_EDIT_PWM_CH), text_data, 99);
        targetCh = strtol(text_data, NULL, 10);
        if (targetCh < 0 or targetCh > 15) {
            MessageBox(NULL, "PWM CH0`15͈̔͊OłB", "Error", MB_OK);
            return;
        }
        writeData[0] = 6 + targetCh*4;

        GetWindowText(GetDlgItem(hWnd, IDC_EDIT_H_EDGE), text_data, 99);
        in_data = (unsigned short)strtol(text_data, NULL, 10);
        if (in_data < 0 or in_data > 4095) {
            MessageBox(NULL, "PWM High Edgel0`4095͈̔͊OłB", "Error", MB_OK);
            return;
        }
        writeData[1] = (BYTE)(in_data & 0x00FF);
        writeData[2] = (BYTE)((in_data >> 8) & 0x00FF);

        GetWindowText(GetDlgItem(hWnd, IDC_EDIT_L_EDGE), text_data, 99);
        in_data = (unsigned short)strtol(text_data, NULL, 10);
        if (in_data < 0 or in_data > 4095) {
            MessageBox(NULL, "PWM Low Edgel0`4095͈̔͊OłB", "Error", MB_OK);
            return;
        }
        writeData[3] = (BYTE)(in_data & 0x00FF);
        writeData[4] = (BYTE)((in_data >> 8) & 0x00FF);

        HID_SMBUS_STATUS status = HidSmbus_WriteRequest(*m_pHidSmbus, m_addressedSlaveAddress,
            writeData, numBytesToWrite);
        if (status != HID_SMBUS_SUCCESS)
        {
            MessageBox(NULL, "PWM SetɎs܂B", "Error", MB_OK);
        }
    }
}


//-------------------------------------------------------------------------------------
//Utility
//-------------------------------------------------------------------------------------

TCHAR *HidSmbus_DecodeErrorStatus(const HID_SMBUS_STATUS status)
{
    TCHAR str[80];

    switch (status)
    {
    case HID_SMBUS_SUCCESS:					wsprintf(str, _T("HID_SMBUS_SUCCESS"));					break;
    case HID_SMBUS_DEVICE_NOT_FOUND:		wsprintf(str, _T("HID_SMBUS_DEVICE_NOT_FOUND"));		break;
    case HID_SMBUS_INVALID_HANDLE:			wsprintf(str, _T("HID_SMBUS_INVALID_HANDLE"));			break;
    case HID_SMBUS_INVALID_DEVICE_OBJECT:	wsprintf(str, _T("HID_SMBUS_INVALID_DEVICE_OBJECT"));	break;
    case HID_SMBUS_INVALID_PARAMETER:		wsprintf(str, _T("HID_SMBUS_INVALID_PARAMETER"));		break;
    case HID_SMBUS_INVALID_REQUEST_LENGTH:	wsprintf(str, _T("HID_SMBUS_INVALID_REQUEST_LENGTH"));	break;
    case HID_SMBUS_READ_ERROR:				wsprintf(str, _T("HID_SMBUS_READ_ERROR"));				break;
    case HID_SMBUS_WRITE_ERROR:				wsprintf(str, _T("HID_SMBUS_WRITE_ERROR"));				break;
    case HID_SMBUS_READ_TIMED_OUT:			wsprintf(str, _T("HID_SMBUS_READ_TIMED_OUT"));			break;
    case HID_SMBUS_WRITE_TIMED_OUT:			wsprintf(str, _T("HID_SMBUS_WRITE_TIMED_OUT"));			break;
    case HID_SMBUS_DEVICE_IO_FAILED:		wsprintf(str, _T("HID_SMBUS_DEVICE_IO_FAILED"));		break;
    case HID_SMBUS_DEVICE_ACCESS_ERROR:		wsprintf(str, _T("HID_SMBUS_DEVICE_ACCESS_ERROR"));		break;
    case HID_SMBUS_DEVICE_NOT_SUPPORTED:	wsprintf(str, _T("HID_SMBUS_DEVICE_NOT_SUPPORTED"));	break;
    case HID_SMBUS_UNKNOWN_ERROR:			wsprintf(str, _T("HID_SMBUS_UNKNOWN_ERROR"));			break;
    default:								wsprintf(str, _T("Unknown Status"));					break;
    }

    return str;
}